function FDAct:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end

local rand = math.random


function FDAct:StartActivity()
	print("START! -- FDAct:StartActivity()!");
	self.playertally = 0;
	self.playerlist = {};
    for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
        if self:PlayerActive(player) and self:PlayerHuman(player) then
		self.playerlist[player + 1] = true;
		self.playertally = self.playertally + 1;
		-- Check if we already have a brain assigned
			if not self:GetPlayerBrain(player) then
				local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(player));
				-- If we can't find an unassigned brain in the scene to give each player, then force to go into editing mode to place one
				if not foundBrain then
					self.ActivityState = Activity.EDITING;
					AudioMan:ClearMusicQueue();
					AudioMan:PlayMusic("Base.rte/Music/dBSoundworks/ccambient4.ogg", -1, -1);
				else
					-- Set the found brain to be the selected actor at start
					self:SetPlayerBrain(foundBrain, player);
					self:SwitchToActor(foundBrain, player, self:GetTeamOfPlayer(player));
					self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
					-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
					self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				end
			end
		end
	end
	self.WList = { --"Grenade Launcher", "Nailgun", "Heavy Sniper Rifle", "Gatling Gun","Napalm Flamer", "Flak Cannon", "Auto Shotgun","Mauler Shotgun", "Bazooka","YAK4700", "Uzi", "M16", "Spas12","Spaz1200",
	"AK-SU", "Avenger Minigun", --[["Boson Blaster",]] "D-Rifle", "Drang", "Flare Cannon", "Beeshot", "M875 Shotgun",
	"MJ-2 Carbine", "M-Mortar", "Puncturer", "Ranseur", "Rigger", "Shunt", "Vindicator RG", "Impeder Launcher", "Laptop gun" }
	self.TechList = { "Gluon Cascade Device", "Inferno Cannon", "Shotcannon", "Fatman", "RPC-1700", "Cremator", "Porcupine", "Sturm", "Gauss SMG", "Wasp SMG", "Hornet Swarm Cannon", "Goldsapper"}
	self.HeavyList = {}
	local t = rand(#self.TechList)
	print("The Enemy has "..self.TechList[t].."!")
	self.HeavyList[1]=self.TechList[t]
	table.remove(self.TechList,t)
	self.SuperWeapons = {"Davy Crockett" } --for now...
	self.AList = {"Soldier Light", "Soldier Heavy", "Browncoat Light", "Browncoat Heavy", "Robot 1", "Robot 2", "Dummy"};
	self.BList = {"Gluon Cascade Grenade","Plan B","Black Bomb","Kamikaze Belt"}
	self.MList = {"S-4","M14-B","Claymore","Hopstring"}
	self.DWList = {"Mac-10", "SawnOff Shotgun", "Magnum", "Mauler", "M79", "M79b"}
	self.SList = {"Gravity Nullifier","EMFG"}
	self.ESpawnTimer = Timer();
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ Team 2");
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(10000, Activity.TEAM_1);
		self:SetTeamFunds(10000, Activity.TEAM_2);
		self:SetTeamFunds(10000, Activity.TEAM_3);
		self:SetTeamFunds(10000, Activity.TEAM_4);
		self.BaseSpawnTime = 6000;
		self.RandomSpawnTime = 8000;
		self.TechTime = 3
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(9000, Activity.TEAM_1);
		self:SetTeamFunds(9000, Activity.TEAM_2);
		self:SetTeamFunds(9000, Activity.TEAM_3);
		self:SetTeamFunds(9000, Activity.TEAM_4);
		self.BaseSpawnTime = 5500;
		self.RandomSpawnTime = 7000;
		self.TechTime = 1.75
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(7000, Activity.TEAM_1);
		self:SetTeamFunds(7000, Activity.TEAM_2);
		self:SetTeamFunds(7000, Activity.TEAM_3);
		self:SetTeamFunds(7000, Activity.TEAM_4);
		self.BaseSpawnTime = 5000;
		self.RandomSpawnTime = 6000;
		self.TechTime = 1.33
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(5000, Activity.TEAM_1);
		self:SetTeamFunds(5000, Activity.TEAM_2);
		self:SetTeamFunds(5000, Activity.TEAM_3);
		self:SetTeamFunds(5000, Activity.TEAM_4);
		self.BaseSpawnTime = 4500;
		self.RandomSpawnTime = 5000;
		self.TechTime = 1
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(3000, Activity.TEAM_1);
		self:SetTeamFunds(3000, Activity.TEAM_2);
		self:SetTeamFunds(3000, Activity.TEAM_3);
		self:SetTeamFunds(3000, Activity.TEAM_4);
		self.BaseSpawnTime = 4000;
		self.RandomSpawnTime = 4500;
		self.TechTime = 0.5
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self:SetTeamFunds(2000, Activity.TEAM_1);
		self:SetTeamFunds(2000, Activity.TEAM_2);
		self:SetTeamFunds(2000, Activity.TEAM_3);
		self:SetTeamFunds(2000, Activity.TEAM_4);
		self.BaseSpawnTime = 3500;
		self.RandomSpawnTime = 4000;
		self.TechTime = 0.33
	end
	self.BaseSpawnTime = self.BaseSpawnTime * 1.3
	self.StartTimer = Timer();
	self.TechTimer = Timer();
	self.TimeLeft = self.BaseSpawnTime + (self.RandomSpawnTime);
	self.tech = 0


end

function FDAct:PrintTechInfo()

	print("Tech level: "..self.tech)
	print("Tech timer: "..self.TechTimer.ElapsedSimTimeS)
	print("Tech time: "..self.TechTime)
	print("TechList:")
	for _,v in ipairs(self.TechList) do
	print(v)
	end
	print("HeavyList:")
	for _,v in ipairs(self.HeavyList) do
	print(v)
	end

end

function FDAct:PauseActivity(pause)
    	print("PAUSE! -- FDAct:PauseActivity()!");
end

function FDAct:EndActivity()
    	print("END! -- FDAct:EndActivity()!");
		
end

function FDAct:UpdateActivity()
local brainpos = {}
	if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then
	MovableMan:OpenAllDoors(false,Activity.NOTEAM)
		-- Clear all objective markers, they get re-added each frame
		self:ClearObjectivePoints();

	--tech!
	if self.TechTimer and self.TechTimer:IsPastSimMS(1000*60*self.TechTime) then
		self.tech = self.tech+1
		if self.Difficulty < GameActivity.MAXDIFFICULTY then self.TechTime=self.TechTime*1.05 end
		self.RandomSpawnTime = self.RandomSpawnTime * 0.933
		print("Enemy tech at level "..self.tech.."!")
		if #self.TechList>0 then
		local t = rand(#self.TechList)
		print("Enemy now has "..self.TechList[t].."!")
		self.HeavyList[#self.HeavyList+1]=self.TechList[t]
		table.remove(self.TechList,t)
		end
		if self.tech == 10 then
			print("Enemy tech MAX!")
			for _,v in ipairs(self.TechList) do
			self.HeavyList[#self.HeavyList+1]=v
			end
			self.TechTimer = false
		else
			self.TechTimer:Reset()
		end
	end

		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				if not self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText("Destroy the enemy brain(s)!", player, 333, 5000, true);
				end
				-- The current player's team
				local team = self:GetTeamOfPlayer(player);
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player);
					self:ResetMessageTimer(player);
					FrameMan:ClearScreenText(player);
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false);
					if self.playerlist[player + 1] == true then
						self.playerlist[player + 1] = false;
						self.playertally = self.playertally - 1;
					end
				else
					--Add brain position to table
					brainpos[self:GetTeamOfPlayer(player)+1] = self:GetPlayerBrain(player).Pos.X;
					--Add objective points
					self:AddObjectivePoint("Protect!", self:GetPlayerBrain(player).AboveHUDPos, team, GameActivity.ARROWDOWN);
					for player2 = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
						if player2 ~= player and self:PlayerActive(player2) and self:PlayerHuman(player2) and MovableMan:IsActor(self:GetPlayerBrain(player2)) then
							local team2 = self:GetTeamOfPlayer(player2);
							self:AddObjectivePoint("Destroy!", self:GetPlayerBrain(player2).AboveHUDPos, team, GameActivity.ARROWDOWN);
						end
					end
				end
			end
		end

		--Spawn the AI.
		if self.CPUTeam == nil then
			self.CPUTeam = Activity.NOTEAM;
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				if self:PlayerActive(player) and not(self:PlayerHuman(player)) then
					local team = self:GetTeamOfPlayer(player);
					self.CPUTeam = team;
				end
			end
		end

		if self.CPUTeam ~= Activity.NOTEAM and self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
			local actor = {};
			for x = 0, math.ceil(rand(4)) do
				local y = rand();
				local weapon
				if y > 0.05 then
					actor[x] = CreateAHuman(self.AList[rand(#self.AList)]);
					actor[x].Team = self.CPUTeam;
					actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
					if self.tech==10 and math.abs( rand()*rand()-y*y )<0.012^2 then
						actor[x]:AddInventoryItem(CreateHDFirearm(self.SuperWeapons[rand(#self.SuperWeapons)]));
						actor[x]:AddInventoryItem(CreateHDFirearm(self.DWList[rand(#self.DWList)]));
					else
						if y<self.tech/25+0.1 then
						actor[x]:AddInventoryItem(CreateHDFirearm(self.HeavyList[rand(#self.HeavyList)]));
						actor[x]:AddInventoryItem(CreateHDFirearm(self.DWList[rand(#self.DWList)]));
						elseif y<0.85 then
						actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[rand(#self.WList)]));
						elseif y<0.96 then
						weapon = self.DWList[rand(#self.DWList)]
						actor[x]:AddInventoryItem(CreateHDFirearm(weapon))
						actor[x]:AddInventoryItem(CreateHDFirearm(weapon.." "))
						else
						actor[x]:AddInventoryItem(CreateHDFirearm(self.DWList[rand(#self.DWList)]));
						actor[x]:AddInventoryItem(CreateHDFirearm(self.DWList[rand(#self.DWList)].." "));
						end
						if y>0.8 and self.tech > 2 then
						actor[x]:AddInventoryItem(CreateTDExplosive(self.BList[rand(#self.BList)]));
						end
						if y<0.2 and self.tech > 5 then
						actor[x]:AddInventoryItem(CreateHeldDevice(self.SList[rand(#self.SList)]));
					end
					
					end
					if rand()>0.7 then
						if rand()>0.8 then
						actor[x]:AddInventoryItem(CreateHDFirearm("Heavy Digger"));
						elseif rand()>0.5 then
						actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
						else
						actor[x]:AddInventoryItem(CreateHDFirearm("Mining Laser"));
						end
					end
				else
					actor[x] = CreateACrab("Dreadnought");
					actor[x].Team = self.CPUTeam;
					actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
				end
			end
			local ship = nil;
			local z = rand()-#actor/12;
			if z > 0.90 then
				ship = CreateACRocket("Drop Crate","Dummy.rte");
			elseif z > 0.80 then
				ship = CreateACRocket("Rocklet","Dummy.rte");
			elseif z > 0.60 then
				ship = CreateACRocket("Rocket MK1","Coalition.rte");
			elseif z > 0.40 then
				ship = CreateACRocket("Rocket MK2","Coalition.rte");
			elseif z > 0.20 then
				ship = CreateACDropShip("Drop Ship","Dummy.rte");
			else
				ship = CreateACDropShip("Drop Ship MK1","Coalition.rte");
			end
			for n = 0, #actor do
				ship:AddInventoryItem(actor[n]);
			end
			ship.Team = self.CPUTeam;
			local w = rand();
			if w > 0.5 then
				ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
			else
				ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
			end
			local dist;
			for _,X in pairs(brainpos) do
			dist = SceneMan:ShortestDistance(ship.Pos,Vector(X,-50),SceneMan.SceneWrapsX).X
			if dist > 0 and dist<900 then ship.Pos.X=ship.Pos.X+900 end
			if dist < 0 and dist>-900 then ship.Pos.X=ship.Pos.X-900 end
			end
			MovableMan:AddActor(ship);
			self.ESpawnTimer:Reset();
			self.TimeLeft = self.BaseSpawnTime + rand(self.RandomSpawnTime);
		end

		--Win/Lose Conditions
		if self.CPUTeam == Activity.NOTEAM then
			if self.playertally == 1 then
				for i = 1, #self.playerlist do
					if self.playerlist[i] == true then
						self.WinnerTeam = i - 1;
						ActivityMan:EndActivity();
						print("Enemy tech was at level "..self.tech)
						if self.TechTimer then print("Enemy tech timer was at "..self.TechTimer.ElapsedSimTimeS) end
					end
				end
			end
		else
			if self.playertally == 0 then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
				print("Enemy tech was at level "..self.tech)
				if self.TechTimer then print("Enemy tech timer was at "..self.TechTimer.ElapsedSimTimeS) end
			end
		end
		
	else
		MovableMan:OpenAllDoors(true,Activity.NOTEAM)
		self.StartTimer:Reset();
		self.TechTimer:Reset()
	end
end