local rand = math.random

function Create(self)
	--Find out who shot the weapon by finding the closest actor within 60 pixels.
    local curdist = 60;
    for actor in MovableMan.Actors do
		local vec = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX)
		local dist = vec.Magnitude
		if dist < curdist then
			curdist = dist
			self.parent = actor
		end
    end

	--If the projectiles has no firer, make it go after anyone.  Otherwise, set its team to that of the firer.
   if MovableMan:IsActor(self.parent) then
	self.Team = self.parent.Team
    else
	self.Team = -1
    end

	self.particles = { }
	for i=1,6 do
		part = CreateMOPixel("Bee Bullet")
		part.Pos = self.Pos+Vector(rand(-6,6),rand(-6,6))
		part.Vel = self.Vel+Vector(rand(-22,22),rand(-22,22))
		if MovableMan:IsActor(self.parent) then
			part:SetWhichMOToNotHit(self.parent,400)
		end
		MovableMan:AddParticle(part)
		self.particles[i] = part
	end

end

function Update(self)
	self.Vel = self.Vel*1.01+Vector(rand(-1,1),rand(-1,1));
	local vec
    for _, particle in ipairs(self.particles) do
		if MovableMan:IsParticle(particle) then
			vec = SceneMan:ShortestDistance(self.Pos,particle.Pos,SceneMan.SceneWrapsX)
			particle:AddForce(vec*-2,Vector(0,0))
		end
	end
end