local rand = math.random

function Create(self)
--The timers that will measure out the projectile's events. And increased mass to cheat the recoil.
    self.LTimer = Timer();
	self.PTimer = Timer();
	self.Mass = 6;
	self.Vel = self.Vel*1.3;

--The projectile's target, currently set to nothing.

    self.target = nil;

--Find out who shot the weapon by finding the closest actor within 60 pixels.
    local curdist = 60;
    for actor in MovableMan.Actors do
	local vec = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX)
	local dist = vec.Magnitude
	if dist < curdist then
			curdist = dist;
			self.parent = actor;
		end
    end

--If the projectile has no firer, make it go after anyone.  Otherwise, set its team to that of the firer.
    if MovableMan:IsActor(self.parent) then
	self.Team = self.parent.Team;
    else
	self.Team = -1;
    end

	self.particles = { }
	for i=1,10 do
		part = CreateMOPixel("Hornet Bullet")
		part.Pos = self.Pos+Vector(rand(-6,6),rand(-6,6))
		part.Vel = self.Vel*1.2+Vector(rand(-15,15),rand(-15,15))
		if MovableMan:IsActor(self.parent) then
			part:SetWhichMOToNotHit(self.parent,700)
		end
		MovableMan:AddParticle(part)
		self.particles[i] = part
	end


end

function Update(self)
--self.Vel = self.Vel*1.008
    if self.LTimer:IsPastSimMS(120) then
	local vec

    for _, particle in ipairs(self.particles) do
		if MovableMan:IsParticle(particle) then
			vec = SceneMan:ShortestDistance(self.Pos,particle.Pos,SceneMan.SceneWrapsX)
			particle:AddForce(vec*-7,Vector(0,0))
		end
	end

	--Get a target.  Go for the closest actor within 120 pixels.

	if not MovableMan:IsActor(self.target) then
	    local curdist = 240;
		local str;
	    for actor in MovableMan.Actors do
		vec = SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX)

		local dist = vec.Magnitude
		if dist < curdist and actor.Team ~= self.Team and SceneMan:CastStrengthSumRay(self.Pos,actor.Pos,0,3)<50 then
		    curdist = dist;
		    self.target = actor;
		end
	    end
	end

	--If the target still exists...
	if MovableMan:IsActor(self.target) then
	vec = SceneMan:ShortestDistance(self.Pos,self.target.Pos,SceneMan.SceneWrapsX)
	    --Adding force
	    self:AddForce(vec*12,Vector(0,0));
    for _, particle in ipairs(self.particles) do
		if MovableMan:IsParticle(particle) then
			vec = SceneMan:ShortestDistance(particle.Pos,self.target.Pos,SceneMan.SceneWrapsX)
			particle:AddForce(vec*15*particle.Mass,Vector(0,0))
		end
	end
	else
	curdist = 120;
	end
end
end